import javax.microedition.lcdui.*;

//o[V(LoX)
class ReversiCanvas extends Canvas {
    //萔
    private final static int
        NONE =-1,//Ȃ
        BLACK=0, //
        WHITE=2; //

    //ϐ
    private int[][] board=new int[8][8];//
    private int     curX;   //J[\XW
    private int     curY;   //J[\YW
    private int     pColor; //΂̐F
    private int     pSize;  //΃TCY
    private int     bX;     //XW
    private int     bY;     //YW
    private String  message;//bZ[W

    //_uobt@O
    private Image    imgOff;//ItC[W
    private Graphics graOff;//ItOtBbNX

    //o[V
    ReversiCanvas() {
        init();
    }

    //
    private void init() {
        for (int j=0;j<8;j++) {
            for (int i=0;i<8;i++) board[j][i]=NONE;
        }
        board[3][3]=WHITE;
        board[3][4]=BLACK;
        board[4][3]=BLACK;
        board[4][4]=WHITE;
        curX=2;
        curY=3;
        pColor=BLACK;
        message=null;
    }

    //`
    public void paint(Graphics g) {
        //ItC[W̐
        if (imgOff==null || imgOff.getHeight()!=getHeight()) {
            imgOff=Image.createImage(getWidth(),getHeight());
            graOff=imgOff.getGraphics();

            //΃TCYƔXYW
            pSize=(getWidth()-10<getHeight()-10)?
                getWidth()-10:getHeight()-10;
            pSize/=8;
            bX=(getWidth() -pSize*8)/2;
            bY=(getHeight()-pSize*8)/2;
        }

        //Ղ̕`
        graOff.setColor(0,150,0);
        graOff.fillRect(0,0,getWidth(),getHeight());
        graOff.setColor(200,200,255);
        graOff.fillRect(bX,bY,pSize*8,pSize*8);
        for (int j=0;j<8;j++) {
            for (int i=0;i<8;i++) {
                graOff.setColor(100,100,255);
                graOff.drawRect(bX+i*pSize,bY+j*pSize,pSize,pSize);
                if (board[j][i]==BLACK) {
                    graOff.setColor(0,0,0);
                    graOff.fillArc(bX+pSize*i+1,bY+pSize*j+1,pSize-2,pSize-2,0,360);
                } else if (board[j][i]==WHITE) {
                    graOff.setColor(255,255,255);
                    graOff.fillArc(bX+pSize*i+1,bY+pSize*j+1,pSize-2,pSize-2,0,360);
                    graOff.setColor(0,0,0);
                    graOff.drawArc(bX+pSize*i+1,bY+pSize*j+1,pSize-2,pSize-2,0,360);
                }
            }
        }

        //J[\̕`
        if (message==null) {
            if (pColor==BLACK) graOff.setColor(20,20,20);
            if (pColor==WHITE) graOff.setColor(230,230,230);
            graOff.drawRect(bX+curX*pSize,bY+curY*pSize,pSize,pSize);
            graOff.drawRect(bX+curX*pSize+1,bY+curY*pSize+1,pSize-2,pSize-2);
        }
        //̕`
        else {
            int dx=getWidth()/2;
            int dy=getHeight()/4;
            graOff.setColor(255,155,155);
            graOff.drawString(message,dx-1,dy-1,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx  ,dy-1,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx+1,dy-1,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx-1,dy  ,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx+1,dy  ,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx-1,dy+1,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx  ,dy+1,g.HCENTER|g.BASELINE);
            graOff.drawString(message,dx+1,dy+1,g.HCENTER|g.BASELINE);
            graOff.setColor(255,0,0);
            graOff.drawString(message,dx,dy,g.HCENTER|g.BASELINE);
        }

        //ʂɔf
        g.drawImage(imgOff,0,0,g.LEFT|g.TOP);
    }

    //L[vXCxg
    public void keyPressed(int keyCode) {
        if (keyCode==0) return;

        switch(getGameAction(keyCode)) {
        case LEFT: if (--curX<0) curX=7;break;
        case RIGHT:if (++curX>7) curX=0;break;
        case UP:   if (--curY<0) curY=7;break;
        case DOWN: if (++curY>7) curY=0;break;
        case FIRE:
            if (message!=null) {
                init();
            } else if (putPiece(pColor,curX,curY,true)) {
                pColor=(pColor==BLACK)?WHITE:BLACK;
                checkWin();
            }
            break;
        }
        repaint();
    }

    //|C^vXCxg
    public void pointerPressed(int x,int y) {
        x-=bX;
        y-=bY;
        if (0<x && x<pSize*8 && 0<y && y<pSize*8) {
            curX=x/pSize;
            curY=y/pSize;
            if (message!=null) {
                init();
            } else if (putPiece(pColor,curX,curY,true)) {
                pColor=(pColor==BLACK)?WHITE:BLACK;
                checkWin();
            }
            repaint();
        }
    }

    //΂u
    private boolean putPiece(int pColor,int x,int y,boolean turn) {
        boolean flag=false;
        if (board[y][x]!=NONE) return false;
        if (turnPiece(pColor,x,y,-1,-1,turn)) flag=true;//
        if (turnPiece(pColor,x,y, 0,-1,turn)) flag=true;//
        if (turnPiece(pColor,x,y, 1,-1,turn)) flag=true;//E
        if (turnPiece(pColor,x,y,-1, 0,turn)) flag=true;//
        if (turnPiece(pColor,x,y, 1, 0,turn)) flag=true;//E
        if (turnPiece(pColor,x,y,-1, 1,turn)) flag=true;//
        if (turnPiece(pColor,x,y, 0, 1,turn)) flag=true;//
        if (turnPiece(pColor,x,y, 1, 1,turn)) flag=true;//E
        return flag;
    }

    //΂𔽓]
    private boolean turnPiece(int pColor,int x,int y,int dx,int dy,boolean turn) {
        for (int i=0;;i++) {
            y+=dy;
            x+=dx;
            //Δzus
            if (y<0 || board.length<=y    ||
                x<0 || board[y].length<=x ||
                board[y][x]==NONE ||
                (board[y][x]==pColor && i==0)) return false;
            //Δzu
            if (board[y][x]==pColor) {
                //΂ЂԂ
                if (turn) {
                    for (;i>=0;i--) {
                        x-=dx;
                        y-=dy;
                        board[y][x]=pColor;
                    }
                }
                return true;
            }
        }
    }

    //s`FbN
    private void checkWin() {
        boolean blackput=false;
        boolean whiteput=false;
        int     black   =0;
        int     white   =0;
        //JEg
        for (int j=0;j<8;j++) {
            for (int i=0;i<8;i++) {
                //΂zu\H
                if (!blackput &&
                    putPiece(BLACK,i,j,false)) blackput=true;
                //΂zu\H
                if (!whiteput &&
                    putPiece(WHITE,i,j,false)) whiteput=true;
                //΂̐
                if (board[j][i]==BLACK) black++;
                //΂̐
                if (board[j][i]==WHITE) white++;
            }
        }
        //bZ[W
        if (!blackput && !whiteput) {
                 if (black>white) message="BLACK WIN!";
            else if (black<white) message="WHITE WIN!";
            else                  message="DRAW";
        }
        //pX
        else {
                 if (pColor==BLACK && !blackput) pColor=WHITE;
            else if (pColor==WHITE && !whiteput) pColor=BLACK;
        }
    }
}