import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.bluetooth.*;

//BluetoothŒʐM({)
public class ChatForm extends Form
    implements CommandListener {
    //萔
    private final static String UUID_STRING=//UUID
        "11112233445566778899AABBCCDDEEFF";

    //GUI
    private StringItem  statusItem;  //Xe[^X
    private TextField   sendField;   //M
    private TextField   receiveField;//M
    private ChoiceGroup deviceGroup; //foCX

    //R}h
    private Command cmdStart;  //T[oJn
    private Command cmdConnect;//T[oɐڑ
    private Command cmdSelect; //I
    private Command cmdSend;   //M

    //Bluetooth
    private LocalDevice     localDevice; //[JfoCX
    private DiscoveryAgent  agent;       //fBXJoG[WFg
    private L2CAPConnection conn;        //ڑ
    private RemoteDevice[]  remoteDevice;//[gfoCX
    private boolean         running;     //s

    //RXgN^
    public ChatForm() {
        super("ChatEx");

        //GUI
        statusItem  =new StringItem("","");
        receiveField=new TextField("M","",256,TextField.ANY);
        sendField   =new TextField("M","",256,TextField.ANY);
        deviceGroup =new ChoiceGroup(null,Choice.EXCLUSIVE);
        append(statusItem);

        //R}h
        cmdStart  =new Command("T[oJn",Command.SCREEN,1);
        cmdConnect=new Command("T[oɐڑ",Command.SCREEN,1);
        cmdSelect =new Command("I",Command.SCREEN,1);
        cmdSend   =new Command("M",Command.SCREEN,1);
        addCommand(cmdStart);
        addCommand(cmdConnect);
        setCommandListener(this);

        try{
            //[JfoCX̎擾
            localDevice=LocalDevice.getLocalDevice();

            //fBXJoG[WFg̎擾
            agent=localDevice.getDiscoveryAgent();
        } catch (Exception e){
            statusItem.setText("G[:"+e.toString());
        }
    }

    //R}hCxg
    public void commandAction(Command c,Displayable s) {
        //T[oJn
        if (c==cmdStart) {
            Thread thread=new Thread(){
                public void run(){
                    startServer();
                }
            };
            thread.start();
        }
        //T[oɐڑ
        else if (c==cmdConnect) {
            //GUI
            statusItem.setText("foCXc");
            removeCommand(cmdConnect);
            removeCommand(cmdStart);
            append(deviceGroup);

            //foCX
            try {
                agent.startInquiry(DiscoveryAgent.GIAC,
                    new DeviceDiscoverer());
            } catch(Exception e){
                statusItem.setText("G[:"+e.toString());
            }
        }
        //I
        else if (c==cmdSelect) {
            //GUI
            statusItem.setText("T[rXc");
            int index=deviceGroup.getSelectedIndex();
            delete(size()-1);
            removeCommand(cmdSelect);

            //T[rX
            try {
                int[]  attrSet={0x0100};//ServiceName
                UUID[] uuidSet={new UUID(UUID_STRING,false)};
                agent.searchServices(attrSet,uuidSet,
                    remoteDevice[index],new ServiceDiscoverer());
            } catch(Exception e) {
                statusItem.setText("G[:"+e.toString());
            }
        }
        //M
        else if (c==cmdSend) {
            Thread thread=new Thread() {
                public void run(){
                    sendMessage();
                }
            };
            thread.start();
        }
    }

    //T[oJn
    public void startServer(){
        //GUI
        statusItem.setText("T[oڑ҂c");
        removeCommand(cmdConnect);
        removeCommand(cmdStart);
        try{
            //fBXJou̎w
            localDevice.setDiscoverable(DiscoveryAgent.GIAC);

            //L2CAPT[rX̐ڑ҂
            L2CAPConnectionNotifier notifier=
                (L2CAPConnectionNotifier)Connector.open(
                "btl2cap://localhost:"+UUID_STRING+";name=ChatEx");
            conn=notifier.acceptAndOpen();
            statusItem.setText("T[os");

            //bZ[WM[v̊Jn
            Thread thread=new Thread(){
                public void run(){
                    receiveMessage();
                }
            };
            thread.start();
        } catch (Exception e) {
            //ؒf
            disconnect();
        }
    }

    //bZ[WM
    public void sendMessage() {
        try {
            //bZ[WM
            byte[] w=sendField.getString().getBytes("UTF-8");
            if (w.length<=conn.getTransmitMTU()) {
                conn.send(w);
                sendField.setString("");
            } else {
                statusItem.setText("bZ[Wł");
            }
        } catch (Exception e) {
            statusItem.setText("G[:"+e.toString());
            running=false;
        }
    }

    //bZ[WM[v̊Jn
    public void receiveMessage(){
        //GUI
        append(sendField);
        append(receiveField);
        addCommand(cmdSend);

        //bZ[WM[v
        running=true;
        try{
            while(running){
                //bZ[WM
                if (conn.ready()){
                    byte[] w=new byte[conn.getReceiveMTU()];
                    int length=conn.receive(w);
                    receiveField.setString(new String(w,0,length,"UTF-8"));
                }

                //X[v
                Thread.sleep(100);
            }
        } catch (Exception e){
            running=false;
        }

        //ؒf
        disconnect();
    }

    //foCX̏
    public void deviceInquiryFinished(RemoteDevice[] remoteDevice,String message) {
        //[gfoCX
        this.remoteDevice=remoteDevice;

        //GUI
        try {
            for (int i=0;i<remoteDevice.length;i++) {
                deviceGroup.append(remoteDevice[i].getFriendlyName(false),null);
            }
            addCommand(cmdSelect);
            statusItem.setText(message);
        } catch(Exception e){
            statusItem.setText("G[:"+e.toString());
        }
    }


    //T[rX̏
    public void serviceSearchFinished(ServiceRecord serviceRecord,String message){
        //GUI
        statusItem.setText(message);
        if (serviceRecord==null) return;
        try{
            //ڑ
            String url=serviceRecord.getConnectionURL(
                ServiceRecord.NOAUTHENTICATE_NOENCRYPT,false);
            conn=(L2CAPConnection)Connector.open(url);
            statusItem.setText("ڑ");

            //bZ[WM[v̊Jn
            Thread thread=new Thread(){
                public void run(){
                    receiveMessage();
                }
            };
            thread.start();
        } catch (Exception e){
            statusItem.setText("G[:"+e.toString());
        }
    }

    //ؒf
    void disconnect() {
        //ؒf
        try {
            running=false;
            if (conn!=null) conn.close();
        } catch (Exception e) {
        }

        //GUI
        statusItem.setText("ؒf");
        while (size()>1) delete(1);
        removeCommand(cmdSend);
    }
}